#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_monster.h"
std::auto_ptr<M_monster> M_monster::msSingleton(nullptr);

int M_monster::GetCount()
{
	return (int)mMapData.size();
}

const M_monsterData* M_monster::GetData(int64_t ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int64_t, M_monsterData>& M_monster::GetMapData()
{
	return mMapData;
}

void M_monster::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_monster.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_monsterData data;
		data.mname = element->Attribute("name");
		data.mtype = element->IntAttribute("type");
		data.mmultiple = element->IntAttribute("multiple");
		data.micon = element->Attribute("icon");
		data.maspect = element->Attribute("aspect");
		data.mspeed = element->FloatAttribute("speed");
		data.msuper_speed = element->FloatAttribute("super_speed");
		data.mzoom_factor = element->FloatAttribute("zoom_factor");
		data.mexp_value = element->IntAttribute("exp_value");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_monster Loaded. Load Data:%u", mMapData.size());
}

void M_monster::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_monster");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_monster");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_monsterData data;
		LuaCfgHelper::readString(L, "name", data.mname);
		LuaCfgHelper::readInt(L, "type", data.mtype);
		LuaCfgHelper::readInt(L, "multiple", data.mmultiple);
		LuaCfgHelper::readString(L, "icon", data.micon);
		LuaCfgHelper::readString(L, "aspect", data.maspect);
		LuaCfgHelper::readFloat(L, "speed", data.mspeed);
		LuaCfgHelper::readFloat(L, "super_speed", data.msuper_speed);
		LuaCfgHelper::readFloat(L, "zoom_factor", data.mzoom_factor);
		LuaCfgHelper::readInt(L, "exp_value", data.mexp_value);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_monster Loaded. Load Data:%u", mMapData.size());
}

void M_monster::Reload()
{
	mMapData.clear();
	Load();
}

M_monster* M_monster::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_monster());
	}
	return msSingleton.get();
}

void M_monster::Release()
{
	msSingleton.reset(nullptr);
}
